import { getStorage } from '@/common/utils/storage.js'
export default {
  data() {
    return {
      // 网点下拉选项
      shopList: [],
      // 网点下拉选项选中的下标
      index: 0,
      // 类型切换选中值
      selected: 1,
      // 是否显示类型切换
      showTypeSwitching: true,
      // 下拉刷新状态
      refresherTriggered: false,
      // 配件类型列表
      accessoriesList: [],
      // 类型选中下标
      accessoriesIndex: -1,
      // 列表数据
      list: [],
      // 名称搜索
      partsName: '',
      option: {},
      apis: {
        default: {
          getGroupUrl: '/app/parts/stock/exist/shop/group/list',
          getStockUrl: '/app/parts/stock/exist/shop/stock/list'
        },
        applicationParts: {
          getGroupUrl: '/app/parts/shop/stock/group/list',
          getStockUrl: '/app/parts/shop/stock/list'
        }
      }
    }
  },
  onLoad(option) {
    this.option = option
    if (!option.partsWebsiteNumber && !option.shopId) {
      this.getShopInfo()
    }
  },
  computed: {
    accessoriesParams() {
      if (this.option.partsWebsiteNumber && this.option.shopId) {
        return {
          identity: this.userInfo.idCard,
          partsWebsiteNumber: this.option.partsWebsiteNumber,
          shopId: this.option.shopId
        }
      }
      var data = this.shopList[this.index]
      if (data) {
        return {
          identity: this.userInfo.idCard,
          partsAttr: ['OLD', 'NEW'][this.selected],
          partsWebsiteNumber: data.partsWebsiteNumber,
          shopId: data.shopId
        }
      } else {
        return false
      }
    },
    userInfo() {
      return getStorage('user')
    },
    idcard() {
      return this.userInfo.idCard
    }
  },
  watch: {
    accessoriesParams(newVal) {
      this.getGroup(newVal)
      this.list = []
    },
    accessoriesList(newVal) {
      if (this.accessoriesIndex !== 0) {
        this.accessoriesIndex = 0
      } else {
        this.getStock()
      }
    },
    accessoriesIndex() {
      this.getStock()
    },
    partsName() {
      this.getStock()
    }
  },
  methods: {
    // 获取网点
    getShopInfo() {
      this.$api
        .get('/app/parts/stock/exist/shop/list', {
          identity: this.idcard
        })
        .then(res => {
          this.shopList = res.data
        })
        .catch(() => {
          this.shopList = []
        })
    },
    // 获取分组
    getGroup(params) {
      if (params) {
        this.$api
          .get(this.apis[this.option.apiType || 'default'].getGroupUrl, params)
          .then(res => {
            this.accessoriesList = res.data
          })
          .catch(() => {
            this.accessoriesList = []
          })
      } else {
        this.accessoriesList = []
      }
    },
    // 获取配件
    getStock() {
      if (this.accessoriesList.length && this.accessoriesList[this.accessoriesIndex]) {
        this.$api
          .get(this.apis[this.option.apiType || 'default'].getStockUrl, {
            ...this.accessoriesParams,
            materialGroupId: this.accessoriesList[this.accessoriesIndex].id,
            partsName: this.partsName
          })
          .then(res => {
            this.list = res.data
          })
          .catch(() => {
            this.list = []
          })
      } else {
        this.list = []
      }
    },
    // 搜索按钮
    search(val) {
      this.partsName = val
    },
    // 监听下拉选项
    bindPickerChange(e) {
      this.index = e.detail.value
    },
    // 滚动到底部
    carScrolltolower(e) {},
    // 触发下拉刷新
    carRefresherrefresh(e) {
      this.refresherTriggered = true
      setTimeout(() => {
        this.refresherTriggered = false
      }, 3000)
    },
    // 下拉刷新结束
    carRefresherrestore(e) {},
    // 点击购买配件
    buyAccessories() {}
  }
}
